/*****************************

	i.ching
	
	Based on PatternOracle
	pattern processing engine
	
	version 0.5.0
	
	s y n c h r o n i z m
	synchronizm@mac.com
	
	(c) 2005
	All Rights Reserved.
	
	-------------------
	ui.js
	
	-------------------
	
******************************/

// init
var flipShown = false;
var animation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, firstElement:null, timer:null};
var winState = false;

function activateWindow(event)
{

	var miniImg = document.getElementById('mini');
	var openImg = document.getElementById('open');
	var clckDn = document.getElementById('taiChi_dn');
	var guill = document.getElementById('guillotine');
	var flipIcon = document.getElementById('flip');
	var flipBkg = document.getElementById('fliprollie');

	// show down click
	clckDn.style.display = 'block';
	guill.style.display = 'block';
	
	// check visibility
	//if(openImg.style.display == 'none' || !openImg.style.display) {
	if(!winState) {
		
		guill.style.top = '24px';
		guill.style.display = 'block';
		openImg.style.display = 'block';
		miniImg.style.display = 'block';
		
		// cast
		castGems();

		// smooth resize
		for(var i=26; i<=240; i=i+12) {

			var winHeight = (i+14) < 240 ? (i+14) : i;
			var guillTop = (i+37) < 240 ? (i) : (i-37);

			// resize when blade emerges
			if((i+14) > 63) {
			
  				window.resizeTo(217, (i+14));
  			
  			}

			// fix display glitch
			if(guillTop < i) {

				guill.style.display = 'none';

			} else {

				guill.style.top =  guillTop + 'px';

			}

			// reset flip icon
			flipIcon.style.bottom = '13px';
			flipBkg.style.bottom = '13px';

		}
		
		window.resizeTo(217, 240);
		guill.style.top = '203px';
		guill.style.display = 'none';
		winState = true;

	} else {

		guill.style.top = '203px';

		// smooth resize
		for(var i=240; i>=63; i=i-12) {

  			window.resizeTo(217, i);
			guill.style.top =  (i-37) + 'px';

			// reset flip icon
			flipIcon.style.bottom = '13px';
			flipBkg.style.bottom = '13px';

		}

		window.resizeTo(217, 63);

		guill.style.display = 'none';
		miniImg.style.display = 'block';
		openImg.style.display = 'none';
		winState = false;

	}

	// hide down click
	clckDn.style.display = 'none';

	// reset flip icon
	flipIcon.style.bottom = '12px';
	flipBkg.style.bottom = '12px';

}

function flpToFront(event) {

	hideBack();

}

function showBack() {

    var front = document.getElementById("front");
    var back = document.getElementById("back");
    var hexagram = document.getElementById("activeHexagram");
    var textLabel = document.getElementById("textLayer");

	// hide data
	hexagram.style.display="none";
	textLabel.style.display="none";
		
    window.resizeTo(217, 240);
        
    if (window.widget)
        widget.prepareForTransition("ToBack");
                
    front.style.display="none";
    back.style.display="block";
        
    if (window.widget)
        setTimeout ('widget.performTransition();', 0);  
}

function hideBack() {

    var front = document.getElementById("front");
    var back = document.getElementById("back");
    var hexagram = document.getElementById("activeHexagram");
    var textLabel = document.getElementById("textLayer");

	// show data
	hexagram.style.display="block";
	textLabel.style.display="block";
        
    if (window.widget)
        widget.prepareForTransition("ToFront");
                
    back.style.display="none";
    front.style.display="block";
    
    // resize
    if(winState) {
    
    		window.resizeTo(217, 240);
    		
    	} else {
    	
    		window.resizeTo(217, 63);
    		
    	}
        
    if (window.widget)
        setTimeout ('widget.performTransition();', 0);
}

function mousemove (event) {

    if (!flipShown)
    {
        if (animation.timer != null)
        {
            clearInterval (animation.timer);
            animation.timer  = null;
        }
                
        var starttime = (new Date).getTime() - 13;
                
        animation.duration = 500;
        animation.starttime = starttime;
        animation.firstElement = document.getElementById ('flip');
        animation.timer = setInterval ("animate();", 13);
        animation.from = animation.now;
        animation.to = 1.0;
        animate();
        flipShown = true;
        
    }
    
}

function mouseexit (event) {

    if (flipShown)
    {
        // fade in the info button
        if (animation.timer != null)
        {
            clearInterval (animation.timer);
            animation.timer  = null;
        }
                
        var starttime = (new Date).getTime() - 13;
                
        animation.duration = 500;
        animation.starttime = starttime;
        animation.firstElement = document.getElementById ('flip');
        animation.timer = setInterval ("animate();", 13);
        animation.from = animation.now;
        animation.to = 0.0;
        animate();
        flipShown = false;
    }
}

function animate() {

    var T;
    var ease;
    var time = (new Date).getTime();
                
        
    T = limit_3(time-animation.starttime, 0, animation.duration);
        
    if (T >= animation.duration)
    {
        clearInterval (animation.timer);
        animation.timer = null;
        animation.now = animation.to;
    }
    else
    {
        ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
        animation.now = computeNextFloat (animation.from, animation.to, ease);
    }
        
    animation.firstElement.style.opacity = animation.now;
}

function limit_3 (a, b, c) {
    return a < b ? b : (a > c ? c : a);
}

function computeNextFloat (from, to, ease) {
    return from + (to - from) * ease;
}

function enterflip(event) {
    document.getElementById('fliprollie').style.display = 'block';
}

function exitflip(event) {
    document.getElementById('fliprollie').style.display = 'none';
}