/*****************************

	i.ching
	
	Based on PatternOracle
	pattern processing engine
	
	version 0.5.0
	
	s y n c h r o n i z m
	synchronizm@mac.com
	
	(c) 2005
	All Rights Reserved.
	
	-------------------
	yao.js
	
	-------------------
	
******************************/

function Yao(y_id, parent_trigram) {

	// functions
	this.parentTrigram = parent_trigram;
	this.initializeYaoState = initializeYaoState;
	this.setEnergies = setEnergies;
	this.resolveState = resolveState;
	this.showYao = showYao;
	this.setState = trace; // overwritten

	// init
	this.yao_id = document.getElementById(y_id);
	this.state = new Object();
	
	// link with style object

	// init
	trace("[Yao] Initializing");

	// initialize
	this.initializeYaoState();	
	
}
	
// initialize state (sets a default state)
function initializeYaoState() {
	
	// create array
	this.state.state_array = new Array(3);
	this.state.energy = 7;
	this.state.flow = true;
	this.state.inner = false;
	this.state.outer = true;
	this.state.mode = "outer";
	
	// Set default (stable yang)
	this.state.state_array[0]=3;
	this.state.state_array[1]=2;
	this.state.state_array[2]=2;
	
	// establish synchronizm
	this.resolveState();
	
}

// set energies
function setEnergies(e1, e2, e3) {
	
	var state = this.state;
	
	trace("[yao] Energy has changed to " + e1 + ", " + e2 + ", " + e3);
	
	// transfer states
	if((e1==2||e1==3)&&(e2==2||e2==3)&&(e3==2||e3==3)) {
		
		state.state_array[0] = e1;
		state.state_array[1] = e2;
		state.state_array[2] = e3;
	
	}
	
	// update and return computation
	return this.resolveState();
	
}
	
// set flow from components
function resolveState() {
	
	var state_description = "";
	var state_movement = "";
	var state_flow = "";
	var changeVector_array = new Array();
	var state = this.state;
	
	state.energy = 0;
	
	// add components
	for(var i=0; i<state.state_array.length; i++) {
		
		state.energy+=state.state_array[i];
		changeVector_array = state.state_array[i];
		
	}
	
	// set flow
	state.flow = state.energy % 2 == 0 ? false : true;
	
	// set balance
	state.balance = (state.energy == 9 || state.energy == 6) ? false : true;
	
	// set manifest and unmanifest
	state.inner = !state.balance ? !state.flow : state.flow;
	state.outer = state.flow;
	
	// report
	state_movement = state.inner == state.outer ? "stable" : "changing";
	state_flow = state.outer ? "yang" : "yin";
	state_description = state_movement + " " + state_flow;
	
	// debug
	if((state.inner == state.outer) != state.balance) {
		
		trace("[yao] states do not agree");
	
	}
	
	trace("[yao] Updated state to " + state.energy + " (" + state_description + ")");
	
	// display
	this.showYao();
	
	// notify
	this.setState(state.flow);
	//this.parentTrigram.computeState();
	
	// compute change vector
	if(!state.balance) {
		
		// yang
		if(state.flow) {
			
			changeVector_array[1] = 2; // change to stable yin by transforming Heaven into Wind
			
		} else {
			
			changeVector_array[1] = 3; // change to stable yang by transforming Earth into Thunder
			
		}
		
	}
	
	return changeVector_array;
	
}

// display
function showYao() {
	
	var state = this.state;
	var yao_id = this.yao_id;
	
	// set states
	if(state.balance) {
	
		if(state.flow) {
		
			yao_id.style.background = "url(Yang.png) no-repeat top left";
			
		} else {
		
			yao_id.style.background = "url(Yin.png) no-repeat top left";
			
		}
		
	} else {
	
		if(state.flow) {
		
			yao_id.style.background = "url(Changing_yang.png) no-repeat top left";
			
		} else {
		
			yao_id.style.background = "url(Changing_yin.png) no-repeat top left";
			
		}
		
	}
	
}
